# encoding: UTF-8
require 'application_helper'

module SolvedClosedFields
	module IssuePatch
		def self.included(base)
			base.send(:include, InstanceMethods)
			base.extend(ClassMethods)

			base.class_eval do
				before_save :set_projectspecific_customfields

				unloadable
			end
		end

		module ClassMethods
		end

		module InstanceMethods
			def set_projectspecific_customfields
				if self.project_id == 15894 || self.project_id == 15924 || self.project_id == 16359
					solved = (self.status_id == 3 && self.status_id_was != 3)
					closed = (self.status_id == 5 && self.status_id_was != 5)
					curts  = "#{DateTime.now.to_formatted_s(:db)}"
					userid = "#{User.current.id}"
					
					self.custom_field_values.each do |c|
						case c.custom_field.id
							when 107
								if solved
									c.value = curts
								end
							when 110
								if closed
									c.value = curts
								end
							when 116
								if solved && c.value != userid
									c.value = userid
								end
							when 113
								if closed && c.value != userid
									c.value = userid
								end
							when 119
								c.value = "#{attachments.count > 0 ? 1 : 0}"
						end
					end
				end
			end  

		end
	end
end

Rails.configuration.to_prepare do
	Issue.send(:include, SolvedClosedFields::IssuePatch)
end

